/* $Id: remote.c,v 0.4 1999/05/19 11:29:05 kjc Exp kjc $ */
/*
 *  Copyright (c) 1996
 *	Sony Computer Science Laboratory Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms of parts of or the
 * whole original or derived work are permitted provided that the above
 * copyright notice is retained and the original work is properly
 * attributed to the author. The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
/* remote.c -- a module common for remote-monitoring */
#include <stdio.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>

#include "cbqmon.h"
#include "ttt.h"
#include "ttt_remote.h"

/* convert a string name to struct sockaddr_in */
int name2sockaddr(char *name, int port, union sockunion *addrp, int family)
{
    unsigned long inaddr;
    struct hostent *hep;

    bzero(addrp, sizeof(union sockunion));
#ifdef INET6
    {
	struct addrinfo hints, *res;
	char portstr[64];
	int error;

	sprintf(portstr, "%d", port);
	memset(&hints, 0, sizeof(struct addrinfo));
	hints.ai_family = family;
	hints.ai_socktype = SOCK_DGRAM;
	if (name == NULL)
	    hints.ai_flags = AI_PASSIVE;

	if ((error = getaddrinfo(name, portstr, &hints, &res)) != 0) {
	    fprintf(stderr, "can't get addrinfo for %s: %s\n",
		    name, gai_strerror(error));
	    return (-1);
	}

	*addrp = *(union sockunion *)res->ai_addr;

	freeaddrinfo(res);
    }
#else /* INET6 */
    addrp->su_sin.sin_family = PF_INET;
#ifndef __svr4__
    addrp->su_sin.sin_len = sizeof(struct sockaddr_in);
#endif
    if (name != NULL) {
	if ((inaddr = inet_addr(name)) != -1)
	    bcopy(&inaddr, &addrp->su_sin.sin_addr, sizeof(inaddr));
	else if ((hep = gethostbyname(name)) != NULL)
	    bcopy(hep->h_addr, &addrp->su_sin.sin_addr, hep->h_length);
	else
	    return (-1);
    }
    else
	addrp->su_sin.sin_addr.s_addr = htonl(INADDR_ANY);
    addrp->su_sin.sin_port = htons(port);
#endif /* INET6 */    
    return 0;
}
